import math
import random
import Conf
from Bloc import Bloc
'''
Created on 25 mars 2019

@author: invite
'''

class StepBloc(object):
    '''
    classdocs
    '''


    def __init__(self, bloc,** keys):
        '''
        Constructor
        '''
        
        if 'protection' in keys :
            self.protection=keys['protection']
        else:
            self.protection=0
            
        if 'side' in keys :
            self.side=keys['side']
        else:
            self.side=random.randint(0,1)
            #self.side=0
            
        random.seed()
        self.c=[]
        


        self.newPath(bloc)

                   
    #def newPath(self,bloc,a,b):
    def newPath(self,bloc):
            
        #rad=random.uniform(0,2*math.pi)
        
        a=bloc.getRotation()
        
        if 0<=a or a<90:
            if self.side:
                b=a+270
            else:
                b=a+90
        elif 90<=a or a<270:
            if self.side:
                b=a-90
            else:
                b=a+90
        elif 270<=a or a<=360:
            if self.side:
                b=a-90
            else:
                b=a-270
        else:
            print("StepBloc angle to big")
            exit(1)
            
        sx=random.randint(Conf.blocSideMin,Conf.blocSideMax)
        sy=random.randint(Conf.blocSideMin,Conf.blocSideMax)
        
                      
        z=bloc.getPz()+bloc.getSz()
        while z > Conf.stepHight:
                    
            px,py = self.getNextHop(bloc.getPx(), bloc.getPy(), bloc.getSx()+Conf.stepLong+sx, \
                                              (b*math.pi)/180)
        
            z-=Conf.stepHight
            
            type=random.random()
            if type > Conf.ratioPyramid :
                bloc=Bloc(sx=sx,sy=sy,sz=z,px=px,py=py,pz=0, \
                        type="meshbox",name="stepBloc",rotation=a,protection=self.protection)
                self.c.append(bloc)
            else:
                bloc=Bloc(sx=sx,sy=sy,sz=-z,px=px,py=py,pz=0, \
                        type="pyramid",name="stepPyra",rotation=a,protection=self.protection)
                self.c.append(bloc)
            
        return
    
        
    def getNextHop(self,pxb,pyb,sy,rad):
        
        if rad>=0 or rad<(math.pi/2):
            px=pxb+(math.sin(rad)*sy)
            py=pyb-(math.cos(rad)*sy)
        elif rad>=(math.pi/2) or rad<math.pi:
            px=pxb-(math.cos(rad-(math.pi/2))*sy)
            py=pyb-(math.sin(rad-(math.pi/2))*sy)            
        elif rad>=math.pi or rad<(3*math.pi)/2:
            px=pxb-(math.sin(math.pi-rad)*sy)
            py=pyb+(math.cos(math.pi-rad)*sy)
        elif rad>=(3*math.pi)/2 or rad<=2*math.pi:
            px=pxb+(math.sin((2*math.pi)-rad)*sy)
            py=pyb+(math.cos((2*math.pi)-rad)*sy)
        
        return px,py
    
    def getList(self):
        return self.c