'''
Created on 4 nov. 2018

@author: invite
'''
import random
import math
from MainCollection import MainCollection
from Collection import Collection
from GroupCircle import GroupCircle
from Forest import Forest
from ForestSin import ForestSin
from Collection import Collection
from Material import Material
from Bloc import Bloc
from Line import Line
from Montagne import Montagne
import Conf
from BaseWay import BaseWay
from StepBloc import StepBloc
from Teleporter import Teleporter


'''
world : x from 0 to 2*Conf.worldSize
        y from 0 to Conf.worldSize
        axial symetrie axe y=Conf.worldsize

'''

class World(object):

    def __init__(self,** keys):
        
        random.seed()
        
        self.cLine=0
        self.cCircle=0
        self.cBigbloc=0
        self.cBigPyra=0
        self.cCollection=0
        self.cForest=0
        self.cForestSin=0
        self.cMontagne=0
        
        self.teleporterId=1
        
        
        #self.montagnes=[]
        self.bigBlocsHight=None
        self.surfaceBigBlocs=0
        
        if random.random()<0.5:
            self.flag=False
        else:
            self.flag=True
        self.flag=False
        #***
        # MAIN COLLECTION
        #***
                
        #diviser par 4 car ctf et group repete 2X 
        # conf.worldsize car   2x*2y !=  x*y
        #self.surfaceCircles=0
        #self.surface=0
        
        self.M=MainCollection()
        # M2 sans flagGap pour baseway
        #self.M2=MainCollection()
     
        #***
        # BASE
        #***
           
        #base1
        sx=random.randint(20,40)
        sy=sx
        sz=1
        if sx>(Conf.worldSize/3):
            px=sx
        else:
            px=random.randint(round(sx*math.sqrt(2)),round((Conf.worldSize*2)-(sx*math.sqrt(2))))
            
        if sy>(Conf.worldSize/3):
            py=sy
        else:
            py=random.randint(round(sy*math.sqrt(2)),int(Conf.worldSize/3))
        
        level=random.randint(1,2)
        
        pz=(level*Conf.stepHight)-sz
        
        self.base1=Bloc(px=px,py=py,pz=pz,sx=sx,sy=sy,sz=sz,type="base",protection=Conf.protectionBase,color=Conf.color1,name="base")

        # base2
        p2x,p2y=self.symetrieAxiale(px,py)
        self.base2=Bloc(px=p2x,py=p2y,pz=pz,sx=sx,sy=sy,sz=sz,rotation=self.base1.getRotation(),type="base",protection=Conf.protectionBase,\
                        color=Conf.color2,name="base")
        if self.flag==True:
            self.M.addZone(Bloc(sx=self.base1.getSx(),sy=self.base1.getSy(),sz=0,type="zone",option="zoneflag TH 2",\
                px=self.base1.getPx(),py=self.base1.getPy(),pz=0,rotation=self.base1.getRotation()))
            self.M.addZone(Bloc(sx=self.base1.getSx(),sy=self.base1.getSy(),sz=0,type="zone",option="zoneflag SH 2",\
                px=self.base1.getPx(),py=self.base1.getPy(),pz=0,rotation=self.base1.getRotation()))
            self.M.addZone(Bloc(sx=self.base1.getSx(),sy=self.base1.getSy(),sz=0,type="zone",option="zoneflag CL 2",\
                px=self.base1.getPx(),py=self.base1.getPy(),pz=0,rotation=self.base1.getRotation()))
        
        #***
        # MAIN
        #***
        
        #m=None
        random.seed()
        #m=self.montagne()
        #self.addBigBlocCollection()
        #self.addBigPyra()
        #self.addCircleCenter()
        #test=False
        if Conf.debug:
            #pass
            print("#*** debug mode")
            #self.addCircleCenter()
            #self.addCircle()
            #self.addCircle()
            #self.addCircle()
            #self.addCircle()
            #self.addForestSin()
            self.addLine()
            self.addLine()
            #for i in range(0,4):
            #self.addCircle()
            #self.ztest()
            #exit(1)
            #self.cBigbloc+=1
        else:

            print("#*** generation 1 part specials")
            spec=random.randint(0,99)
                
            if spec < 20 or self.M.getRemplissage()<=0.23:
                self.cBigbloc+=1
            elif spec < 50:
                self.addCircleCenter()
            elif spec < 100:
                self.addLine()
                
            
            
            print("#*** generation 2 part")
            t=[]
            for i in range(0,6):
                t.append(random.randint(0,99))
            t=sorted(t)
            
            while self.M.getSurface() < self.M.getSurfaceLimite():
                print("#*** current "+str(self.M.getSurface()))
                building=random.random()*100
                rare=random.random()*100
                
                if building < t[0]:
                    print("#***forest")
                    self.addForest()
    
                elif building < t[1]:
                    print("#***collection")
                    self.addCollection()
                
                elif building < t[2]:
                    print("#***montagne")
                    self.montagne()
                    #self.montagnes.append(self.montagne())
                    #self.M.addCollection(self.montagnes[-1])
                    
                    #if self.cMontagne >= 1 :
                    #    continue
                    #m=self.montagne()
                
                elif building < t[3] and rare<50:
                  
                    if self.cBigbloc < Conf.nbBigBlocMax:
                        self.cBigbloc+=1
                    else:
                        continue
                    
                    #self.addBigBlocCollection()
            
                elif building < t[4]:
                    print("#***circle")
                    self.addCircle()
                        
                elif building < t[5]:
                    if self.cLine<1:
                        print("#*** Line")
                        self.addLine()
                    else:
                        continue
                        
                elif building < 101 and rare<70:
                    print("#***bigPyra")
                    self.addBigPyra()
                                    
                else:
                    continue
                    #print ("probleme base")
                    #exit()
            
        print("#*** surface after generation "+str(self.M.getSurface()))
        #* acces to highest bloc
        
        # unlock addBlocCollection
        self.M.setTestSurface(False)
        
        #######################
        # deplacer cette partie dans la collection
        ##############
        for b in self.M.getC():
            if b.getSz()> Conf.stepHight and b.getSz() < 2*Conf.stepHight and b.getSx()>8 and b.getSy()>8 and b.getName!="baseWayPyra":
                if random.random() < 0.2:
                    self.M.addCollection(StepBloc(b),True)
        
        #***
        # on ajoute la montagne a la fin            
        # ecrase les bloc existant pour eviter flag gap en hauteur
        #print ("#*** surface before montagne = "+str(self.M.getSurface()))
        #if self.cMontagne >= 1 :
        #    self.M.addCollectionAndOverride(m)        

        # road
        print ("#*** surface before road = "+str(self.M.getSurface()))
        self.surfaceRoad=0
                    
        while self.M.getSurface() > self.M.getSurfaceLimite() :
            self.road()
        
        # test
        #self.ztest()
        #self.addBigBlocCollection()
        #self.M.addBloc(Bloc(px=self.base1.getPx(),py=self.base1.getPy(),pz=0,sx=5,sy=5,sz=100,type="box"))
        #self.M.addBloc(Bloc(px=self.base2.getPx(),py=self.base2.getPy(),pz=0,sx=5,sy=5,sz=100,rotation=self.base1.getRotation(),type="box"))
        
        #***
        # END
        #***
        
        # override important bloc at the end
        print ("#*** surface before base = "+str(self.M.getSurface()))
        self.M.override(self.base1)
        self.M.override(self.base2)
        #self.M.addBloc(self.base1)
        #self.M.addBloc(self.base2)
        self.M.addCollection(BaseWay(self.base1),True)
        
        # keep at this place because raise base
        print ("#*** surface before bigbloc = "+str(self.M.getSurface()))
        for i in range(0,int(self.cBigbloc)):
            print("#***bigBloc "+str(self.surfaceBigBlocs)+" / "+str(Conf.bigBlocsSurfaceLimite))
                    
            if self.surfaceBigBlocs>Conf.bigBlocsSurfaceLimite:
                break
            else:
                self.addBigBlocCollection()

        
        print ("#*** surface before flagGap = "+str(self.M.getSurface()))
        
        #########################
        #if not Conf.debug:
        self.M.checkSmallGap()
        #########################
        
        
        #******
        #self.addTeleporter()
 
        self.M.draw()
        
        #self.M.toString()
        #self.M.getHighest()
        if not Conf.debug:
            print("#*** t ",end='')
            print(t)
        print("#***remplissage :"+str(self.M.getRemplissage()))
        print ("#*** surface limite initiale = "+str(int((self.M.getRemplissage()*((Conf.worldSize*2)**2))/2)))
        print ("#*** surface generee fin= "+str(self.M.getSurface()))
        print ("#*** gap: "+str(Conf.gap))
        print("#***[ FIN ]***")
        

    def addCollection(self):
        
        random.seed()
        nb=random.randint(Conf.nbBlocMaxPerCollection/10,Conf.nbBlocMaxPerCollection)
        
        rotation=self.randRotation()

        protection=Conf.protectionCollection
        
        type=self.randType()
            
        #****************
        #*taille fixe
        #****************
        if random.random() < Conf.ratioTailleFixe:
            sizeX=random.randint(1,Conf.collectionSizeXmax)
            sizeY=random.randint(1,Conf.collectionSizeYmax)
            sizeZ=random.randint(1,Conf.collectionSizeZmax)
            
            c=Collection(nb=nb,protection=protection,type=type,sizeX=sizeX,sizeY=sizeY,sizeZ=sizeZ,rotation=rotation, \
                         name="collection"+str(self.cCollection))
            
        #****************
        #*taille variable
        #****************    
        else:
            sizeXmax=random.randint(Conf.collectionSizeXmin,Conf.collectionSizeXmax)
            sizeYmax=random.randint(Conf.collectionSizeYmin,Conf.collectionSizeXmax)
            sizeZmax=random.randint(Conf.collectionSizeZmin,Conf.collectionSizeZmax)
            
            c=Collection(nb=nb,protection=protection,type=type,sizeXmin=Conf.collectionSizeXmin, \
                         sizeYmin=Conf.collectionSizeYmin,sizeZmin=Conf.collectionSizeZmin,sizeXmax=sizeXmax, \
                         sizeYmax=sizeYmax,sizeZmax=sizeZmax,rotation=rotation,name="collection"+str(self.cCollection))
                
        self.M.addCollection(c,True)
        #self.surface+=c.getSurface()/2
        #print ("#collection added - s = "+str(c.getSurface()))
        self.cCollection+=1
        
    def addBigBlocCollection(self):

        # TODO
        # clean area or protection, add collection and tele on it
        random.seed()
        #c=Collection()
        
        rotation=0

        protection=Conf.protectionBigBloc
        #m=MainCollection()
        
        sx=random.randint(Conf.bigBlocSideSizeMin,Conf.bigBlocSideSizeMax)
        sy=random.randint(Conf.bigBlocSideSizeMin,Conf.bigBlocSideSizeMax)
        
        # surface limite
        surfaceRestante=Conf.bigBlocsSurfaceLimite-self.surfaceBigBlocs
        surface=sx*sy*8
        if surface > surfaceRestante:
            if sx>sy:
                sx=round(surfaceRestante/(4*sy))+1
            else:
                sy=round(surfaceRestante/(4*sx))+1
                
        # all big bloc have same hight
        
        if self.bigBlocsHight !=None:
            hight=self.bigBlocsHight
        else:
            hight=self.standardizeSz(random.randint(Conf.bigBlocSizeZmin,Conf.bigBlocSizeZmax))
            self.bigBlocsHight=hight
        
        
        px=random.randint(sx,(2*Conf.worldSize)-sx)
        py=random.randint(sy,(2*Conf.worldSize)-sy)
        
        # put bigbloc near border to avoid flag gap
        if px<sx+Conf.gap:
            px=sx-1
        elif px> (2*Conf.worldSize)-(sx+Conf.gap):
            px=(2*Conf.worldSize)-(sx+1)
        
        if py<sx+Conf.gap:
            py=sy-1
        elif py> (2*Conf.worldSize)-(sy+Conf.gap):
            py=(2*Conf.worldSize)-(sy+1)
        # dig under big bloc. need to be done after bloc creation cause standardSz function
        sz=hight
        pz=random.randint(0,sz-1)
        if pz < 3:
            pz=0
        sz-=pz
        
        #if Conf.debug:
        #    px=self.base1.getPx()
        #    py=self.base1.getPy()
        #    hight=self.base1.getPz()+5
        
        #raise bloc. if base on bigbloc increase protection
        if  self.M.raiseArea(sx,sy,px,py,rotation,hight) == 1 :
                protection=Conf.protectionImportant
        
        #add 1rst teleporter before because of cleanARea  
        # pas de teleporter si pz>0 (le clean area detruit des bases)
        if pz>0:              
            self.M.cleanArea(20,20,px,py,0)
            t=Teleporter(id=self.teleporterId,px=px,py=py,pz=hight,rotation=90)
            self.M.addBloc(t)

        # create 1st big bloc
        b=Bloc(sx=sx,sy=sy,sz=hight,px=px,py=py,type="meshbox",protection=protection,rotation=rotation,\
               name="bigBloc")
        b.setPz(pz)
        b.setSz(sz)
                                                   
        self.M.addBloc(b)
        
        # add 2nd teleporter on floor
        if pz>0:
            t2=Teleporter(id=self.teleporterId,px=px,py=py,pz=0,sz=hight-4,num=2,rotation=90)
            self.M.addBloc(t2)   
        
        # 2 Stepblocs 
        self.M.addCollection(StepBloc(b,protection=Conf.protectionBigBloc,side=0),True)
        self.M.addCollection(StepBloc(b,protection=Conf.protectionBigBloc,side=1),True)
        
        #symetrie
        p2x,p2y=self.symetrieAxiale(px,py)

        #add 1rst teleporter before because of cleanARea     
        if pz>0:
            self.teleporterId+=1
            self.M.cleanArea(20,20,p2x,p2y,0)
            self.M.addBloc(t.cloneCtf(self.teleporterId))
            self.M.addBloc(t2.cloneCtf(self.teleporterId))
        
        self.M.raiseArea(sx,sy,p2x,p2y,rotation,hight)
       
        b2=Bloc(sx=sx,sy=sy,sz=sz,px=p2x,py=p2y,pz=pz,type="meshbox",protection=protection, \
                    rotation=rotation,name="bigBloc")
                    
        b2.setPz(pz)
        b2.setSz(sz)
        
        self.M.addBloc(b2)
        
        # ajout SW et SB under big blocs
        if pz>3 and self.flag==True:
            px = random.randint((b.getPx()-b.getSx()),b.getPx()+b.getSx())
            py = random.randint((b.getPy()-b.getSy()),b.getPy()+b.getSy())
            self.M.addZone(Bloc(sx=5,sy=5,sz=0,type="zone",option="zoneflag SB 2",\
                                px=px,py=py,pz=0,rotation=b.getRotation()))
            px = random.randint((b.getPx()-b.getSx()),b.getPx()+b.getSx())
            py = random.randint((b.getPy()-b.getSy()),b.getPy()+b.getSy())
            self.M.addZone(Bloc(sx=5,sy=5,sz=0,type="zone",option="zoneflag SW 2",\
                                px=px,py=py,pz=0,rotation=b.getRotation()))
            #self.M.addZone(Bloc(sx=b.getSx()-20,sy=b.getSy()-20,sz=0,type="zone",option="zoneflag OO 1",\
            #                   px=b.getPx(),py=b.getPy(),pz=pz+sz,rotation=b.getRotation()))
                      
        self.surfaceBigBlocs+=surface
        if pz>0:
            self.teleporterId+=1
        
    def addBigPyra(self):
        
        
        rotation=self.randRotation()
        protection=Conf.protectionBigPyra

        #****************
        #*taille variable
        #****************    
        #else:
        sx=random.randint(Conf.bigPyraSizeXmin,Conf.bigPyraSizeXmax)
        sy=random.randint(Conf.bigPyraSizeYmin,Conf.bigPyraSizeYmax)
        sz=random.randint(Conf.bigPyraSizeZmin,Conf.bigPyraSizeZmax)
        
        p=Bloc(sx=sx,sy=sy,sz=sz,type="pyramid",rotation=rotation,protection=Conf.protectionBigPyra)
        self.M.addBloc(p)
        
        p2x,p2y=self.symetrieAxiale(p.getPx(),p.getPy())
        p2=Bloc(px=p2x,py=p2y,sx=sx,sy=sy,sz=sz,rotation=rotation,type="pyramid",protection=Conf.protectionBigPyra)
        self.M.addBloc(p2)        

        self.cBigPyra+=1
        
    
    def addForest(self):
        
        random.seed()
        surface=random.randint(0,Conf.ratioForestSize*(Conf.worldSize**2))
        posxmax=random.randint(Conf.forestLongMin, Conf.worldSize)
        posymax=round(surface/posxmax)
        if posymax > Conf.worldSize:
            posymax = Conf.worldSize - 1
        
        densite=random.uniform(Conf.densiteForestMin,Conf.densiteForestMax)
        
        #*******************************
        #* generation d une collection
        rotation=self.randRotation()
        protection=Conf.protectionForest
        type=self.randType()
        
        #*taille fixe
        
        if random.random() < Conf.ratioTailleFixe:
                    
            sizeX=random.randint(Conf.forestSizeXmin,Conf.forestSizeXmax)
            #on evite les rectrangles trop long, pour eviter les trou a drapeau
            sizeY=random.randint(Conf.forestSizeYmin,Conf.forestSizeYmax)
            #if sizeY > 2*sizeX:
            #    sizeY=2*sizeX
            sizeZ=random.randint(Conf.forestSizeZmin,Conf.forestSizeZmax)
            
            nb=round( (posxmax*posymax*densite)/( sizeX * sizeY ) )
        
            
            c=Collection(nb=nb,protection=protection,type=type,sizeX=sizeX,sizeY=sizeY,sizeZ=sizeZ,rotation=rotation,name="Forest")
            
            #*taille variable
            
        else:
    
            sizeXmax=random.randint(1,Conf.forestSizeXmax)
            sizeYmax=random.randint(1,Conf.forestSizeYmax)
            sizeZmax=random.randint(1,Conf.forestSizeZmax)
            
            nb=int((posxmax*posymax*densite)/ (((sizeXmax+Conf.forestSizeXmin)/2)*((sizeYmax+Conf.forestSizeYmin)/2)) )
            
            c=Collection(nb=nb,protection=protection,type=type,sizeXmin=Conf.forestSizeXmin, \
                         sizeYmin=Conf.forestSizeYmin,sizeZmin=Conf.forestSizeZmin, \
                         sizeXmax=sizeXmax,sizeYmax=sizeYmax,sizeZmax=sizeZmax,rotation=rotation,name="Forest")
        
        
        #print("X"+str(posxmax)+"/"+str((2*Conf.worldSize)-posxmax))
        #shX=fabs(random.randint(0,(2*Conf.worldSize)-(2*posxmax)))
        #print("Y"+str(posymax)+"/"+str((2*Conf.worldSize)-posymax))
        #shY=fabs(random.randint(0,(2*Conf.worldSize)-(2*posymax)))
        shX=random.randint(posxmax,(2*Conf.worldSize)-posxmax)
        shY=random.randint(posymax,(2*Conf.worldSize)-posymax)  
        f=Forest(shX=shX,shY=shY,posxmax=posxmax,posymax=posymax,name="Forest",collection=c)
        self.M.addCollection(f,True)
        
        #self.surface+=c.getSurface()
        #print("#forest"+str(self.cForest)+" densite: "+str(densite)+" - c surface: "+str(c.getSurface()))
            
        self.cForest+=1
        #print ("#forest added - s = "+str(c.getSurface()))
    
    def addForestSin(self):
        
        protection=Conf.protectionForest
        periode=random.randint(200,Conf.worldSize)
        h=random.randint(40,int(Conf.worldSize/2))
        """
        rotation=0
        
        sx=random.randint(4,15)
        sy=sx
        sz=random.randint(Conf.blocSzMin,20)
        sx=10
        sy=10

        
        #h=random.randint(100,Conf.worldSize)
        
        nb=periode        
        #nb=round(((Conf.worldSize/periode)*h)/((sx+sy)/2))
        #periode=200
        #h=100
        #nb=200
        
        c=Collection(nb=nb,protection=protection,type=type,sizeX=sx,sizeY=sy,sizeZ=sz,rotation=rotation)
        """
        c=Collection(nb=0,protection=protection,type="box")
        self.M.addCollection(ForestSin(c,periode=periode,h=h,name="forestSin"),True)
        
        self.cForestSin+=1
        return
    
    def addTeleporter(self):
        for y in range(100,2*Conf.worldSize,200):
            for x in range(100,2*Conf.worldSize,200):
                self.M.dropBloc(Bloc(sx=0.56,sy=5,sz=12,type="teleporter",option="border 1.12",\
                    px=x,py=y,pz=0,rotation=90,protection=Conf.protectionTeleporter))
            
        """
        teleporter telebas1
          position -150 0 0
          size 0.56 4.48 12
          border       1.12
          rotation 0    
        end
        teleporter telebas2
          position 150 0 0
          size 0.56 4.48 12
          border       1.12
          rotation 0    
        end
        box
          position 0 0 9999
          size 10 10 1
        end
        
        teleporter telehaut1
          position -0.2 0 10000
          size 0.1 4.48 12
          border 0
          rotation 0    
        end
        teleporter telehaut2
          position 0.2 0 10000
          size 0.1 4.48 12
          border 0
          rotation 0    
        end
        link
          from telebas1:f
          to telehaut1:f
        end
        link
          from telebas1:b
          to telehaut1:f
        end
        link
          from telebas2:f
          to telehaut2:b
        end
        link
          from telebas2:b
          to telehaut2:b
        end
        link
          from telehaut1:b
          to telehaut1:f
        end
        link
          from telehaut1:f
          to telebas1:b
        end
        link
          from telehaut2:f
          to telehaut2:b
        end
        link
          from telehaut2:b
          to telebas2:f
        end
        """
        return
            
    def montagne(self):
        
        random.seed()
        
        #*******************************
        #* generation d une collection
        #rotation=self.randRotation()
        protection=Conf.protectionMontagne
        # type=self.randType()
                
        #*taille 
        step=random.randint(Conf.montagneStepMin,Conf.montagneStepMax)
        
        montagneSizeX=random.randint(Conf.montagneSizeMin,Conf.montagneSizeMax)
        montagneSizeY=random.randint(Conf.montagneSizeMin,Conf.montagneSizeMax)
        
        sizeX=random.randint(Conf.montagneBlocSizeXmin,Conf.montagneBlocSizeXmax)
        sizeY=random.randint(Conf.montagneBlocSizeYmin,Conf.montagneBlocSizeYmax)
        
        hight1=(montagneSizeX/sizeX)*step
        hight2=(montagneSizeY/sizeY)*step
        
        if hight1 > hight2:
            hight=hight2
        else:
            hight=hight1
        
        centerX=random.randint(round(montagneSizeX/2),(2*Conf.worldSize)-round(montagneSizeX/2))
        centerY=random.randint(round(montagneSizeY/2),(2*Conf.worldSize)-round(montagneSizeY/2))
        
        #centerX=self.base1.getPx()
        #centerY=self.base1.getPy()
        
        rotation=self.randRotation()
        
        #print("#hight="+str(hight)+"/step="+str(step)+"sizeX="+str(sizeX)+"sizeY="+str(sizeY)+"centerX"+str(centerX)+"centerY="+str(centerY)+ \
                                     #"montagneSizeX="+str(montagneSizeX)+"montagneSizeY="+str(montagneSizeY))
        
        m=Montagne(hight=hight,step=step,sizeX=sizeX,sizeY=sizeY,centerX=centerX,centerY=centerY, \
            montagneSizeX=montagneSizeX,montagneSizeY=montagneSizeY,rotation=rotation,name="montagne"+str(self.cMontagne),\
            flag=self.flag,protection=protection)
        

        self.M.addCollection(m,True)
        #on divise la surface de la montagne par 2!
        #self.surface+=m.getSurface()/2
            
        self.cMontagne+=1
        
        return m
    
    def addCircleCenter(self):
        """    
        rotation=self.randRotation()

        """        
        rayon =random.randint(100,300)
        self.M.addCollection(GroupCircle(rayon=rayon,name="Circle"),False)   
        
        self.cCircle+=1
    

            
    def addCircle(self):
        
        random.seed()
        
        rayon=random.randint(Conf.circleRayonMin,Conf.circleRayonMax)
                
        #****************
        #*taille fixe
        #****************
        if random.random() < Conf.ratioTailleFixe:
            blocSize="fixe"
            
        #****************
        #*taille variable
        #****************    
        else:
            blocSize="variable"
            
        if Conf.debug:
            blocSize="variable"
            
        shX=random.randint(rayon,(Conf.worldSize*2)-rayon)
        shY=random.randint(rayon,(Conf.worldSize*2)-rayon)
        
        self.M.addCollection(GroupCircle(shX=shX,shY=shY,rayon=rayon,name="Circle",blocSize=blocSize),True)   
        
        """
        if rayon<70 and nb >10 and self.flag==True:
            self.M.addZone(Bloc(sx=10,sy=10,sz=0,type="zone",option="zoneflag SB 1",\
                                    px=shX,py=shY,pz=0,protection=5))
        """
        self.cCircle+=1

 
    def addLine(self):
        
        self.M.addCollection(Line(name="Line"),False)
        
        self.cLine+=1

    
    def randRotation(self):
        random.seed()
        if random.random() < Conf.ratioRotationRandom :
            rotation=0
        else:
            rotation=random.randint(0,360)
            #if random.random() < 0.5:
            #    rotation=0
            #else:
            #    rotation=45
                
        return rotation
    
    def randType(self):
        random.seed()
        #****************
        #*pyra or box
        #****************
        if random.random() < Conf.ratioRandomCollection:
            type="random"
        elif random.random()< Conf.ratioPyramid:
            type="pyramid"
        else:
            type="box"
        
        return type
    
    def road(self):

        roadWide=random.randint(Conf.roadWideMin,Conf.roadWideMax)
        roadLength=random.randint(Conf.roadLengthMin,Conf.roadLengthMax)
        maxp=round((2*Conf.worldSize)-roadLength)
        rotation=random.randint(0,360)
        
        if random.randint(0,1):
            px=random.randint(0,maxp)
            py=random.randint(0,maxp)
        else:
            px=0
            py=0
        
        if random.randint(0,1):
            sx=roadWide
            sy=roadLength
        else:
            sx=roadLength
            sy=roadWide
        
        self.M.cleanArea(sx,sy,px,py,rotation)
        px,py=self.symetrieAxiale(px, py)
        self.M.cleanArea(sx,sy,px,py,rotation)
        
        self.surfaceRoad+=sx*sy*2


    def setColor(self,color):
         self.color=color
         
    """
    def standardizeSz(self,sz):
        u=Conf.stepHight
        
        #gateway case and small bloc sz < u/2
        if sz <= u/2:
            return sz
        
        n=int(sz/u)
        if sz%u > u/2 :
            ssz=(n+1)*u
        else:
            ssz=n*u
        return ssz
    """
    def standardizeSz(self,sz):
        u=Conf.stepHight
 
        #gateway case and small bloc sz < u/2
        if sz <= u/2:
            return sz
        
        n=int(sz/u)
        if sz%u > u/2 :
            ssz=(n+1)*u
        else:
            ssz=n*u
        return ssz
    
    def symetrieAxiale(self,x,y):
        if x>Conf.worldSize:
            px=Conf.worldSize-(x-Conf.worldSize)
        else:
            px=Conf.worldSize+(Conf.worldSize-x)
            
        if y>Conf.worldSize:
            py=Conf.worldSize-(y-Conf.worldSize)
        else:
            py=Conf.worldSize+(Conf.worldSize-y)
            
        return px,py

            
    def ztest(self):
        
        #self.addLine()
        #self.addCircle()
        #self.addCircle()
        #for i in range(0,5):
        #self.addLine()
        #self.addMontagne()
        #self.addForest()
        #self.addForest()
        #self.addCollection()
        #self.addCollection()
        #self.addCollection()
        #self.addCollection()
        #self.addCollection()
        #self.opposite()
        c=Collection(nb=0,name="test")
        #c.add(Bloc(sx=4,sy=4,sz=16,px=-110,py=10,rotation=0,c=c.getC()))
        #c.add(Bloc(sx=4,sy=4,sz=16,px=-110,py=19,rotation=0,c=c.getC()))
        
        #c.add(Bloc(sx=4,sy=4,sz=15,px=10,py=10,rotation=0,c=c.getC()))
        #c.add(Bloc(sx=4,sy=4,sz=15,px=10,py=20,rotation=0,c=c.getC()))
        #self.M.addCollection(c)
        
        
        
        ###############
        #
        #
        # ADD ,c=self.c
        #
        #################
        c.add(Bloc(sx=6,sy=4,sz=15,px=585,py=241,rotation=0,color="1 0 0",type="box",protection=0))
        #c.add(Bloc(sx=4,sy=4,sz=15,px=75,py=65,rotation=150,type="box"))
        c.add(Bloc(sx=3,sy=2,sz=15,px=590,py=233,rotation=0,type="box",protection=0))
        c.add(Bloc(sx=2,sy=1,sz=15,px=595,py=228,rotation=0,type="box",protection=0))
    
        
        #c.add(Bloc(sx=4,sy=4,sz=15,px=75,py=-90,rotation=90))
        #c.add(Bloc(sx=4,sy=4,sz=15,px=60,py=-95,rotation=95))
        #c.add(Bloc(sx=4,sy=4,sz=15,px=60,py=-80,rotation=100))
        #c.add(Bloc(sx=4,sy=4,sz=15,px=60,py=-65,rotation=105))
        #c.add(Bloc(sx=4,sy=4,sz=15,px=60,py=-50,rotation=110))
        #c.add(Bloc(sx=4,sy=4,sz=15,px=60,py=-35,rotation=115))
        #c.add(Bloc(sx=4,sy=4,sz=15,px=60,py=-20,rotation=120))
        #c.add(Bloc(sx=4,sy=4,sz=15,px=60,py=-5,rotation=125))
        #c.add(Bloc(sx=4,sy=4,sz=15,px=60,py=10,rotation=130))
        
        #c.add(Bloc(sx=4,sy=4,sz=15,px=60,py=25,rotation=135))
        #c.add(Bloc(sx=4,sy=4,sz=15,px=60,py=40,rotation=140))
        #c.add(Bloc(sx=4,sy=4,sz=15,px=60,py=55,rotation=145))
        #c.add(Bloc(sx=4,sy=4,sz=15,px=60,py=70,rotation=150))
        
        #c.add(Bloc(sx=4,sy=4,sz=15,px=45,py=80,rotation=155))
        #c.add(Bloc(sx=4,sy=4,sz=15,px=45,py=65,rotation=160))
        #c.add(Bloc(sx=4,sy=4,sz=15,px=45,py=50,rotation=165))
        #c.add(Bloc(sx=4,sy=4,sz=15,px=45,py=35,rotation=170))
        #"c.add(Bloc(sx=4,sy=4,sz=15,px=45,py=20,rotation=175))
        #c.add(Bloc(sx=4,sy=4,sz=15,px=45,py=5,rotation=180))
        
        #c.add(Bloc(sx=4,sy=4,sz=15,px=-90,py=90,rotation=0))
        #c.add(Bloc(sx=4,sy=4,sz=15,px=90,py=-95,rotation=0))
        #c.add(Bloc(sx=4,sy=4,sz=15,px=90,py=-80,rotation=5))
        #c.add(Bloc(sx=4,sy=4,sz=15,px=90,py=-65,rotation=10))
        #c.add(Bloc(sx=4,sy=4,sz=15,px=90,py=-50,rotation=15))
        #c.add(Bloc(sx=4,sy=4,sz=15,px=90,py=-35,rotation=20))
        #c.add(Bloc(sx=4,sy=4,sz=15,px=90,py=-20,rotation=25))
        #c.add(Bloc(sx=4,sy=4,sz=15,px=90,py=-5,rotation=30))
        #c.add(Bloc(sx=4,sy=4,sz=15,px=90,py=10,rotation=35))
        #c.add(Bloc(sx=4,sy=4,sz=15,px=90,py=25,rotation=40))
        #c.add(Bloc(sx=4,sy=4,sz=15,px=90,py=40,rotation=45))
        #c.add(Bloc(sx=4,sy=4,sz=15,px=90,py=55,rotation=50))
        #c.add(Bloc(sx=4,sy=4,sz=15,px=90,py=75,rotation=55))
        #c.add(Bloc(sx=4,sy=4,sz=15,px=75,py=85,rotation=60))
        #c.add(Bloc(sx=4,sy=4,sz=15,px=75,py=65,rotation=65))
        #c.add(Bloc(sx=4,sy=4,sz=15,px=75,py=50,rotation=70))
        #c.add(Bloc(sx=4,sy=4,sz=15,px=75,py=35,rotation=75))
        #c.add(Bloc(sx=4,sy=4,sz=15,px=75,py=20,rotation=80))
        #c.add(Bloc(sx=4,sy=4,sz=15,px=75,py=5,rotation=85))
        #c.add(Bloc(sx=4,sy=4,sz=15,px=90,py=-95,rotation=90))
        
        self.M.addCollection(c,True)
        
        #self.addForest()
        #self.addForest()
        return
    
    
    """                
    def cotecote(self):
        
        i=random.randint(1,2)
        if i==1:
            wallMaterial=Material(name="wall",color=[0,0,0,0.3])
            rotation=((180*math.atan(self.base1.getPy()/self.base1.getPx())) / math.pi)+90
            wall=Bloc(type="meshbox",shootthrough=True,matref="wall",sx=Conf.wallSize,sy=2,sz=80,rotation=rotation,px=Conf.worldSize,py=Conf.worldSize,protection=5)        
            wallMaterial.draw()
            wall.draw()
        if i==2:
            step=random.randint(Conf.montagneStepMin,Conf.montagneStepMax)
        
            montagneSizeX=random.randint(Conf.montagneSizeMin,Conf.montagneSizeMax)
            montagneSizeY=random.randint(Conf.montagneSizeMin,Conf.montagneSizeMax)
            
            sizeX=random.randint(Conf.montagneBlocSizeXmin,Conf.montagneBlocSizeXmax)
            sizeY=random.randint(Conf.montagneBlocSizeYmin,Conf.montagneBlocSizeYmax)
            
            hight1=(montagneSizeX/sizeX)*step
            hight2=(montagneSizeY/sizeY)*step
            
            if hight1 > hight2:
                hight=hight2
            else:
                hight=hight1
            
            rotation=self.randRotation()
            m=Montagne(hight=hight,step=step,sizeX=sizeX,sizeY=sizeY,centerX=0,centerY=0, \
            montagneSizeX=montagneSizeX,montagneSizeY=montagneSizeY,rotation=rotation,name="montagne"+str(self.cMontagne))
            self.M.addCollectionAndOverride(m)
            

        self.opposite()

        return
    
    def middle(self):
        
        print("#middle")

        self.opposite()
        return
    """
    
    # generation differente en fonction de la position de la base
    """
    diag_world=math.sqrt(2)*Conf.worldSize
    if self.base1.getPx() > Conf.worldSize:
        x=self.base1.getPx()-Conf.worldSize
    else:
        x=Conf.worldSize-self.base1.getPx()
    if self.base1.getPy() > Conf.worldSize:
        y=self.base1.getPy()-Conf.worldSize
    else:
        y=Conf.worldSize-self.base1.getPy()
    diag_base=math.sqrt((x**2)+(y**2))
    n=diag_world/diag_base
    """
    """
    #CHANGER ICI POUR TESTER
    #n=2
    if n >=1.5:
        #print()
        #self.cotecote()
    #elif n >= 1.5
        #self.test()
        self.middle()
    else:
        self.opposite()
    """
    
    
    #self.M.symCtf()
    #self.M.loadCollectionInMatrice(self.M.getC)
        