'''
Created on 28 nov. 2018


@author: invite
'''
import random
import Conf
import math
from Bloc import Bloc
import Conf
import random
from math import cos
from math import sin
from math import tan
from Collection import Collection
from FlagGapFunction import FlagGapFunction
from Material import Material

class Floor(object):
    '''
    classdocs
    '''
    def __init__(self, ** keys):

        self.c=[]

        random.seed()
        #self.c=collection.getList()
        self.shX=0
        self.shY=0
        self.shZ=0


        if 'name' in keys :
            self.name=keys['name']
        else:
            self.name="unknown"

        if 'sx' in keys :
            self.sx=keys['sx']
        else:
            self.sx=Conf.wallSize/4
        
        if 'pxMax' in keys :
            self.pxMax=keys['pxMax']
        #else:
        #    print("floor need pxMax")
        #    exit()
            
        if 'pyMax' in keys :
            self.pyMax=keys['pyMax']
        #else:
        #    print("floor need pyMax")
        #    exit()
        
        if 'pz' in keys :
            self.pz=keys['pz']
        #else:
        #    print("floor need pz")
        #    exit()
        
        
            
       # if 'shX' in keys :
       #     self.shX=keys['shX']
       # if 'shY' in keys :
       #     self.shY=keys['shY']
                    
        for o in self.c:
            o.setPx(random.randint(0,self.pxMax))
            o.setPy(random.randint(0,self.pyMax))
            
        if self.shX != 0 or self.shY !=0:
            self.shift()


  
       
    def draw(self):   
        wallMaterial=Material(name="wall",color=[0,0,0,0.3])
        wallMaterial.draw()
        f=[]
        f.append(Bloc(type="meshbox",shootthrough=True,matref="wall",sx=self.sx,sy=Conf.worldSize,sz=1,rotation=45,px=0,py=0,protection=1,c=self.c))
        #f.append(Bloc(type="meshbox",shootthrough=True,matref="wall",sx=self.sx,sy=Conf.worldSize,sz=1,rotation=0,px=-Conf.worldSize+self.sx,py=0,protection=True))
        #f.append(Bloc(type="meshbox",shootthrough=True,matref="wall",sx=self.sx,sy=Conf.worldSize,sz=1,rotation=0,px=Conf.worldSize-self.sx,py=0,protection=True))
        #f.append(Bloc(type="meshbox",shootthrough=True,matref="wall",sx=self.sx,sy=Conf.worldSize-(2*self.sx),sz=1,rotation=90,px=0,py=Conf.worldSize-self.sx,protection=True))
        #f.append(Bloc(type="meshbox",shootthrough=True,matref="wall",sx=self.sx,sy=Conf.worldSize-(2*self.sx),sz=1,rotation=90,px=0,py=-Conf.worldSize+self.sx,protection=True))
        
        print("#floor "+self.name+ "- nb blocs: "+str(self.len()))
        #print("#floor "+self.name+ "- surface totale: "+str(self.pxMax*self.pyMax))
        for b in f:
            b.setPz(25)
            b.draw()
        
    def getList(self):
        return self.c
    
    def getName(self):
        return self.name

    
    def len(self):
        return len(self.c)
       
    def shift(self):
        for o in self.c:
            o.xShift(self.shX)
            o.yShift(self.shY)
        
        
    def getPxMax(self):
        return self.pxMax
        
    def getPyMax(self):
        return self.pyMax
           
    def setShift(self,x,y,z):
        self.shX=x
        self.shY=y
        self.shZ=z
        
    def setPxMax(self,x):
        self.pxMax=x
        
    def setPyMax(self,y):
        self.pyMax=y