'''
Created on 6 nov. 2018

@author: invite
'''
import math
from Bloc import Bloc
import Conf
import random
from math import cos
from math import sin
from math import tan
from Collection import Collection
from FlagGapFunction import FlagGapFunction

class MainCollection(object):
    '''
    classdocs
    '''

    def __init__(self, ** keys):
        random.seed()
        self.c=[]
        self.z=[]
        self.matrice=[]
        self.lastPointWithBlocChecked=None
        self.funcList=[]
        #self.matgap=[]
        self.cpt=0
        self.isBloc=False
        self.pzMax=0
        self.hightMax=0
        
        self.testSurface=True
        self.remplissage=random.uniform(Conf.remplissageMin,Conf.remplissageMax)
        self.surfaceLimite=int((self.remplissage*((Conf.worldSize*2)**2))/2)
        self.surface=0

        
        max=(2*Conf.worldSize)
        
        for x in range(max):
            self.matrice.append([])
            for y in range(max):
                 self.matrice[x].append(False)
                 self.matrice[x][y]=[]
                
        #if 'surfaceLimite' in keys :
        #    self.surfaceLimite=keys['surfaceLimite']
        #else:
        #    self.surfaceLimite=None
                        
    def addBloc(self,o):  
        self.c.append(o)
        self.addToMatrice(o)
        if o.getPz() > self.pzMax:
            self.pzMax=o.getPz()
        
        if o.getPz()+o.getSz() > self.hightMax:
            self.hightMax=o.getPz()+o.getSz()
        #p=o.cloneCtf()
        #self.c.append(p)
        #self.addToMatrice(p)
        
    def addCollection(self,c,sym):
            
        #self.c.append(c)
        for o in c.getList():
            self.addBloc(o)
            
            if sym:
                o2=o.cloneCtf()
    
                self.addBloc(o2)
            
            if self.testSurface==True and self.surface > self.surfaceLimite :
                #print("AddCollection surface limite :"+str(self.surfaceLimite)+"/ surface "+str(self.surface))
                #exit(1)
                return
            
        return

    def addCollectionAndOverride(self,c):
        
        # delete blocs BEFORE add new ones
        
        for o in c.getList():
            self.cleanArea(o.getSx(),o.getSy(),o.getPx(),o.getPy(),o.getRotation())
            
            o2=o.cloneCtf()
            self.cleanArea(o2.getSx(),o2.getSy(),o2.getPx(),o2.getPy(),o2.getRotation())
            
        self.addCollection(c,True)
        
        return
    
    def addToMatrice(self,o):  
        self.boxToMatrice(self.addToMatriceFunc, o)
        
    def addToMatriceFunc(self,x,y,o):
        max=(2*Conf.worldSize)
        
        if x>=0 and x<max:
            if y>=0 and y<max:
                if len(self.matrice[x][y])==0:
                    if o.getName()=="montagne":
                        self.surface+=0.5
                    else:
                        self.surface+=1
                self.matrice[x][y].append(o)
                
    def addZone(self,z):

        self.z.append(z)
            
        z2=z.cloneCtf()
    
        self.z.append(z2)
            
        return
    """   
    def fillArea(self,sx,sy,px,py):
        
        if len(self.matrice) == 0:
            print ("#fillArea need matrice initialised")
            exit()
            
        surface=0
        
        xMin=px-sx+Conf.worldSize
        xMax=px+sx+Conf.worldSize
        yMin=py-sy+Conf.worldSize
        yMax=py+sy+Conf.worldSize
        for x in range(xMin,xMax):
            for y in range(yMin,yMax):
                if len(self.matrice[x][y])==0:
                    self.c.append(Bloc(px=x,py=y,sz=40,c=self.c))
        return 
    """
    def cleanArea(self,sx,sy,px,py,rotation):
        #self.cleanAreaList.clear()
        
        o=Bloc(sx=sx,sy=sy,px=px,py=py,rotation=rotation)
        self.boxToMatrice(self.cleanAreaFunc, o)
        return 
        
    def cleanAreaFunc(self,x,y,o):
        max=(2*Conf.worldSize)
        
        if x>=0 and x<max:
            if y>=0 and y<max:
                
                        
                listref=[]
                for o in self.matrice[x][y]:
                    listref.append(o)
                    
                for o in listref:
                    self.removeBloc(o)
                    #self.cleanAreaList.append(o)
                    """
                    if o.getType()=="base": 
                        continue
                    else:
                        self.removeBloc(o)
                    """
                        #self.removeBlocFromMatrice(o)
                        #self.c.remove(o)
                    
        return
            
        
    """
    def makeBridgeCentraleSym(self):
        
        for o in self.c:
            if o.getSx()>5 and o.getSy()>5 and o.getSz()>7 and o.getSz()<17:
                y=10
                z=1
                x=math.sqrt(o.getPx()**2+o.getPy()**2)
                rotation=(180*math.atan(o.getPy()/o.getPx())) / math.pi
                b=Bloc(sx=x,sy=y,sz=z,px=0,py=0,pz=(o.getSz()-z),rotation=rotation,c=self.c)
                b.setProtection(True)
                o.setProtection(True)
                self.c.append(b)
                
                return
    """             

    def draw(self):
        for z in self.z:
            z.draw()
        for o in self.c:
           o.draw()
           
           
    def getC(self):
        return self.c
    """
    def getHightMax(self):
        res=sorted(self.c,key=lambda Bloc: (Bloc.sz+Bloc.pz),reverse=True)
        for o in res:
            if o.getType()=="box" or o.getType()=="meshbox":
                print("#*** higest box "+str(res[0].getSz()+res[0].getPz()) )
                return (res[0].getSz()+res[0].getPz())
        return None
    """
    """
    def getHighest(self):
        res=sorted(self.c,key=lambda Bloc: Bloc.sz,reverse=True)
        for o in res:
            if o.getType()=="box" or o.getType()=="meshbox":
                x,y=o.symetrieAxiale(o.getPx(),o.getPy())
            
                for b in self.matrice[x][y]:
                    if b.getSx()==o.getSy() and b.getSz()==o.getSz() and b.getSz()==o.getSz():
                        print("#*** higest "+str(res[0].getSz()) )
                        return o,b
        return None
    """
    def getRemplissage(self):
        return self.remplissage
    
    def getSurface(self):
        return self.surface
    
    def getSurfaceLimite(self):
        return self.surfaceLimite
        
    def gapCount(self,X,Y,hight):
        
        #***
        # count distance between bloc
        # enable on ctf to avoid flag drop in inacessible gap
        # if gap < Conf.gap :
        #  bloc deleted delete from main collection and matrice
        #***
        
        x=X
        y=Y
        blocList=[]

        #***
        # pas de bloc
        #***
        #if len(self.matrice[x][y])==0 or self.testAllAreDriveThrought(self.matrice[x][y]):
        
        # make tmp list for this high level
        for o in self.matrice[x][y]:
            if (o.getPz()+o.getSz()) > hight  and o.getPz() <= hight  :
                blocList.append(o)
            
        if len(blocList)==0:
            if self.isBloc is True:
                self.cpt=1
                self.isBloc=False
            else:
                self.cpt+=1
            return
        #***
        # bloc
        #***    
        else:
    
            if self.isBloc is False:
                self.isBloc=True
                
                # If gap is too small blocs are deleted 
                if self.cpt<Conf.gap and self.cpt!=0:
                    #self.matgap[x][y]=True
                    
                    # check highest protection
                    protection=0
                    for o in blocList:
                        if o.getProtection()>protection:
                            protection=o.getProtection()
                        
                    if protection != 0 and self.lastPointWithBlocChecked != None:
                        
                        x2,y2=self.lastPointWithBlocChecked
                        protection2=0
                        blocList2=[]
                        
                        for o in self.matrice[x2][y2]:
                            if (o.getPz()+o.getSz()) > hight  and o.getPz() <= hight  :
                                blocList2.append(o)
                        
                        # check highest protection of latest bloc place
                        for o in blocList2:
                            if o.getProtection()>protection2:
                                protection2=o.getProtection()
                                                        
                        if protection > protection2:
                            #x,y=x2,y2
                            blocList=blocList2
                            self.lastPointWithBlocChecked=[X,Y]
                            self.isBloc=True
                        else:
                            self.isBloc=False
                            self.cpt+=1
                    
                    
                    for o in blocList:
                        self.removeBloc(o)
                    
                    return

            self.lastPointWithBlocChecked=[X,Y]
            return
                        
    def checkSmallGap(self):
        
        #***
        # parcour de la  map 
        # pour chaque point on lance self.gapCount
        # - balayage a partir du milieu de la carte pour une meilleure symetrie
        # - un balayage par stepHight
        #***
        
        #print("#main collection before checkSmallGap: "+str(len(self.getC())))
        
        #hight=Conf.stepHight*6
        if Conf.debug:
            print ("#*** checkSmallGap start")
        n=int(self.pzMax/Conf.stepHight)+1
        
        for i in range(0,n):
        #for i in range(0,1):
        #for i in (0,3):
            
            print("#*** start checkSmallGap Level "+str(i)+"/"+str(n-1)+" surface "+str(self.getSurface()))
            hight=Conf.stepHight*i
            max=(2*Conf.worldSize)
            
            if Conf.debug:
                print("#*** checkSmallGap x")
            for x in range(0,max):
                
                self.isBloc=False
                self.cpt=0
                self.lastPointWithBlocChecked=None
                for y in range(0,max):
                    self.gapCount(x, y,hight)
            
            if Conf.debug:
                print("#*** checkSmallGap y")    
            for y in range(0,max):
                
                self.bloc=False
                self.cpt=0
                self.lastPointWithBlocChecked=None
                for x in range(0,max):     
                    self.gapCount(x, y,hight)
                
                
                """
                self.bloc=False
                self.cpt=0
                self.lastPointWithBlocChecked=None
                for x in range(Conf.worldSize-(Conf.gap+2),max):     
                    self.gapCount(x, y,hight)
                
                self.isBloc=False
                self.cpt=0
                self.lastPointWithBlocChecked=None
                for x in range(Conf.worldSize+(Conf.gap+2),0,-1):     
                    self.gapCount(x, y,hight)
                """
            print("#*** end checkSmallGap Level "+str(i)+"/"+str(n-1)+" surface "+str(self.getSurface()))
            
        #print("#main collection after checkSmallGap: "+str(len(self.getC())))
        # on bouche les trous
        #for x in range(0,max):
        #    for y in range(0,max):
        #        if self.matgap[x][y]:
        #            self.addBloc(Bloc(sx=1,sy=1,sz=20,px=x,py=y,type="box"))
                                
    
    def override(self,o):
        # clean area BEFORE add a new bloc
        self.cleanArea(o.getSx(),o.getSy(),o.getPx(),o.getPy(),o.getRotation())
        self.addBloc(o)
     
        
    def raiseArea(self,sx,sy,px,py,rotation,sz):

        self.funcList.clear()
        o=Bloc(sx=sx,sy=sy,px=px,py=py,rotation=rotation)
        self.boxToMatrice(self.raiseAreaFunc, o)
        res=0
        """
        if sz>=45:
            baseRaise=0.1
        else:
            baseRaise=Conf.stepHight
        """    
        for o in self.funcList:
            # exception for big bloc
            if o.getName() == "bigBloc" or o.getName() == "montagne" or o.getName()=="baseWayPyra" or o.getName()=="teleporter" \
            or o.getName() == "Line" or o.getName() == "LineGw":
                continue
            elif o.isRaised():
                continue       
                """
            elif o.getName()=="baseWayPyra":
                if o.getSz()+o.getPz() > sz+baseRaise-0.9 :
                    self.removeBloc(o)
                else:
                    continue
                """
            elif o.getType()=="base" or o.getColor()==Conf.colorBaseWay:
                if sz>o.getPz()+o.getSz():
                    o.setPz(sz-1)
                    o.setSz(1)
                    res=1
                else:
                    continue
            
            else:
                o.setSz(o.getSz()+sz)
            
            o.setIsRaised(True)
            
        return res
        
    def raiseAreaFunc(self,x,y,o):
        max=(2*Conf.worldSize)
                
        if x>=0 and x<max:
            if y>=0 and y<max:
                
                for o in self.matrice[x][y]:
                    if self.funcList.count(o)==0:
                        self.funcList.append(o)
        return
            

    
    def removeBlocFunc(self,x,y,o):
        
        max=(2*Conf.worldSize)
        
        if x>=0 and x<max:
            if y>=0 and y<max:
                #if self.matrice[x][y].count(o)!=0:
                self.matrice[x][y].remove(o)
                
                if len(self.matrice[x][y])==0:
                    self.surface-=1
                """
                try:
                    self.matrice[x][y].remove(o)
                except ValueError:
                    pass
                """

                 
    def removeBloc(self,o):
        # on ne supprime pas baseway
        if o.getName()!="baseBlueWay" and o.getType()!="base" and o.getName()!="LineGw":
            self.boxToMatrice(self.removeBlocFunc, o)
            self.c.remove(o)
            """
            if o.getSym()!=None:
                #print(o)
                #print(o.getSym())
                #print("***")
                self.boxToMatrice(self.removeBlocFunc, o.getSym())
                if self.c.count(o) != 0:
                    self.c.remove(o.getSym())
                    #print("REMOVE")
                    #print(o.getSym())
            else:
                print("#WARNING this obj has sym = None")
                o.toString()
            """                    
    def symCtf(self,c):
        symCollection=Collection(nb=0,name="sym")
        for o in c:
            symCollection.add(o.cloneCtf())
        return symCollection
    
    
    def setSurfaceLimite(self,s):
        self.surfaceLimite=s
                    
    def toString(self):
        max=(2*Conf.worldSize)
         
        for x in range(0,max):
            print("")
            print("#",end = '')
            for y in range(0,max):
        
                if len(self.matrice[x][y])==0:
                    print(".",end = '')
                else:
                    print("x",end = '')
        
    def setTestSurface(self,b):
        self.testSurface=b
                    
    def boxToMatrice(self,func,o):
        
        #****
        # parcour l ensemble des point l objet dans la matrice
        # et y applique la fonction func
        #***
        
        f=FlagGapFunction(o)
        a=f.getAngle()
    
        if  a<90 :
            for x in range(f.getXmin(),f.getXmax()):                
                
                if f.getDeltaX()< f.getDeltaXX():
                    if x < f.getXmin()+f.getDeltaX():
                        for y in range(f.wSide(x),f.nSide(x)):
                            #print( "1 x: "+str(x)+"/// y: "+str(y))
                            func(x,y,o)
                       
                    elif x < f.getXmax()-f.getDeltaX():
                        for y in range(f.sSide(x),f.nSide(x)):
                            #print( "1 x: "+str(x)+"/// y: "+str(y))
                            func(x,y,o)
                
                    else:
                        for y in range(f.sSide(x),f.eSide(x)):
                            #print( "1 x: "+str(x)+"/// y: "+str(y))
                            func(x,y,o)

                            
                
                if f.getDeltaX()> f.getDeltaXX():
                    
                    if x < f.getXmin()+f.getDeltaXX():
                        #print( "4+ x: "+str(x)+"/// ymin: "+str(f.wSide(x))+"/ ymax: "+str(f.nSide(x)))
                        for y in range(f.wSide(x),f.nSide(x)):
                            #print( "1 x: "+str(x)+"/// y: "+str(y))
                            func(x,y,o)

                
                    elif x < f.getXmax()-f.getDeltaXX():
                        #print( "5+ x: "+str(x)+"/// ymin: "+str(f.wSide(x))+"/ ymax: "+str(f.eSide(x)))
                        for y in range(f.wSide(x),f.eSide(x)):
                            #print( "1 x: "+str(x)+"/// y: "+str(y))
                            func(x,y,o)

                
                    else:
                        #print( "6+ x: "+str(x)+"/// ymin: "+str(f.sSide(x))+"/ ymax: "+str(f.nSide(x)))
                        for y in range(f.sSide(x),f.eSide(x)):
                            #print( "1 x: "+str(x)+"/// y: "+str(y))
                            func(x,y,o)

                            
                

        elif a>=90:
            #print ( str(f.getXmin())+"**X**"+str(f.getXmax()))
            for x in range(f.getXmin(),f.getXmax()):  
                
                if f.getDeltaX()< f.getDeltaXX():              
               
                    if x < f.getXmin()+f.getDeltaX():                                   
                        #print( "1+ x: "+str(x)+"/// ymin: "+str(f.nSide(x))+"/ ymax: "+str(f.eSide(x)))
                        for y in range(f.nSide(x),f.eSide(x)):
                            #print( "1 x: "+str(x)+"/// y: "+str(y))
                            func(x,y,o)

                        
                    elif x < f.getXmax()-f.getDeltaX():
                        #print( "2+ x: "+str(x)+"/// ymin: "+str(f.nSide(x))+"/ ymax: "+str(f.sSide(x)))
                        #print( str ("1  "+str(f.nSide(x)))+"///"+str(f.sSide(x)))
                        for y in range(f.nSide(x),f.sSide(x)):
                            #print( "1 x: "+str(x)+"/// y: "+str(y))
                            func(x,y,o)

                        
                    else:
                        #print( "3+ x: "+str(x)+"/// ymin: "+str(f.wSide(x))+"/ ymax: "+str(f.sSide(x)))
                        #print( str ("2  "+str(f.nSide(x)))+"///"+str(f.wSide(x)))
                        for y in range(f.wSide(x),f.sSide(x)):
                            #print( "1 x: "+str(x)+"/// y: "+str(y))
                            func(x,y,o)


                                
                if f.getDeltaX()> f.getDeltaXX():              

                    #print( "*** deltaX: "+str(f.getDeltaX())+"/ deltaXX: "+str(f.getDeltaXX()))
                    if x < f.getXmin()+f.getDeltaXX():
                        #print( "4+ x: "+str(x)+"/// ymin: "+str(f.nSide(x))+"/ ymax: "+str(f.eSide(x)))
                            
                        for y in range(f.nSide(x),f.eSide(x)):
                            #print( "1 x: "+str(x)+"/// y: "+str(y))
                            func(x,y,o)


                        
                    elif x < f.getXmax()-f.getDeltaXX():
                        #print( "5+ x: "+str(x)+"/// ymin: "+str(f.wSide(x))+"/ ymax: "+str(f.eSide(x)))
                        #print( str ("1  "+str(f.nSide(x)))+"///"+str(f.sSide(x)))
                        for y in range(f.wSide(x),f.eSide(x)):
                            #print( "1 x: "+str(x)+"/// y: "+str(y))
                            func(x,y,o)


                        
                    else:
                        #print( str ("2  "+str(f.nSide(x)))+"///"+str(f.wSide(x)))
                        #print( "6+ x: "+str(x)+"/// ymin: "+str(f.wSide(x))+"/ ymax: "+str(f.sSide(x)))
                        for y in range(f.wSide(x),f.sSide(x)):
                            #print( "1 x: "+str(x)+"/// y: "+str(y))
                            func(x,y,o)

                         
                    
        else:
            print("erreur flagGapFunction a:"+str(a))
            exit(1)                           
        
        
    def ztest(self):
        for o in self.c:
            if o.getType()=="base":
                print ("base found")
                exit(0)