'''
Created on 28 mars 2019

@author: invite
'''
import random
import Conf

class Teleporter(object):
    '''
    classdocs
    '''


    def __init__(self, **keys):
        '''
        Constructor
        '''
        """
                teleporter telehaut2
          position 0.2 0 10000
          size 0.1 4.48 12
          border 0
          rotation 0    
        end
        link
          from telebas1:f
          to telehaut1:f
        end
        link
          from telebas1:b
          to telehaut1:f
        end
        """
        
        random.seed()
       
        self.protection=Conf.protectionTeleporter
        
        if 'c' in keys :
            self.c=keys['c']
        else:
            self.c=None
            
        if 'sx' in keys :
            self.sx=abs(int(keys['sx']))
        else:
            self.sx=0.56
            
        if 'sy' in keys :
            self.sy=abs(int(keys['sy']))
        else:
            self.sy=4.48
            
        if 'sz' in keys :
            self.sz=int(keys['sz'])
        else:
            self.sz=15
        
        if 'px' in keys :
            self.px=int(keys['px'])
        else:
            self.px=random.randint(0,2*Conf.worldSize)
            
        if 'py' in keys :
            self.py=int(keys['py'])
        else:
            self.py=random.randint(0,2*Conf.worldSize)
                        
        if 'pz' in keys :
            self.pz=int(keys['pz'])
        else:
            self.pz=0
            
        if 'border' in keys :
            self.border=int(keys['border'])
        else:
            self.border=1.12
            
        """
        if 'protection' in keys :
            self.protection=keys['protection']
        else:
            self.protection=0
        """
        
        if 'rotation' in keys :
            self.rotation=keys['rotation']
        else:    
            self.rotation=int(360*random.random())

        self.name="teleporter"
        self.type="teleporter"
        
        
        if 'id' in keys :
            self.id="tele"+str(keys['id'])
        else:
            print("teleporter need an id")
            exit(1)
        
        if 'num' in keys :
            self.num=keys['num']
        else:
            self.num=1
        
            
    def cloneCtf(self,id):
        
        if self.rotation is None:
            self.rotation=0
            
        r=self.rotation+180
        if r>=360:
            r-=360
        
        px,py=self.symetrieAxiale(self.px, self.py)
        
        c=Teleporter(sx=self.sx,sy=self.sy,sz=self.sz,px=px,\
                     py=py,pz=self.pz,\
                     rotation=r,c=self.c,name=self.name,id=id,num=self.num)
            
        return c
           
    def draw(self):
    
        print("# "+str(self.name)+" "+str(self.id)+str(self.num))
        print ("box")
        print ("  position "+str(self.px-Conf.worldSize)+" "+str(self.py-Conf.worldSize)+" "+str(self.pz))     
        print ("  size "+str(self.sx+25)+" "+str(self.sy+25)+" "+str(0.1))
        print ("  rotation "+str(self.rotation))
        print ("end")
        print ("teleporter "+str(self.id)+str(self.num))
        print ("  position "+str(self.px-Conf.worldSize)+" "+str(self.py-Conf.worldSize)+" "+str(self.pz+0.1))     
        print ("  size "+str(self.sx)+" "+str(self.sy)+" "+str(self.sz))
        print ("  rotation "+str(self.rotation))
        print ("  border "+str(self.border))
        print ("end")
        
        
        print ("link")
        print ("from "+str(self.id)+str(self.num)+":b")
        if self.num==1:
            print ("to "+str(self.id)+"2:f")
        else:
            print ("to "+str(self.id)+"1:f")
        print ("end")
        
        print ("link")
        print ("from "+str(self.id)+str(self.num)+":f")
        if self.num==1:
            print ("to "+str(self.id)+"2:b")
        else:
            print ("to "+str(self.id)+"1:b")
        print ("end")
        
    def getProtection(self):    
        return self.protection 
        
    def getName(self):
        return self.name
    
    def getPx(self):
        return self.px
    
    def getPy(self):
        return self.py
                                
    def getPz(self):
        return self.pz  
    
    def getRotation(self):
        return self.rotation  
    
    def getSx(self):
        return self.sx
    
    def getSy(self):
        return self.sy
        
    def getSz(self):
        return self.sz
    
    def getType(self):
        return self.type
    
    def symetrieAxiale(self,x,y):
        if x>Conf.worldSize:
            px=Conf.worldSize-(x-Conf.worldSize)
        else:
            px=Conf.worldSize+(Conf.worldSize-x)
            
        if y>Conf.worldSize:
            py=Conf.worldSize-(y-Conf.worldSize)
        else:
            py=Conf.worldSize+(Conf.worldSize-y)
            
        return px,py
